This file documents facilities of SDOS in CoCo 128K/256K configuration.

* Runs SDOS 1.1H with SDOS/ES: 1 foreground user, 1 background job

* Foreground user has direct access to 6Kb screen memory at top of
  address space (so foreground can do fast graphics).
  Character I/O of 24 lines by 42/51 is done via SDOS, which provides
  full ASCII, cursor positioning, erase-to-eol and erase screen functions.
  Foreground user also has access to keyboard, and direct access
  to CoCo I/O space (although he should not disturb devices known
  to SDOS). User space is expanded from 32k on single user CoCo SDOS
  to 57Kb under SDOS/ES.

* ColorGraphics.ASM option for BASIC compiler is provided to give
  direct Graphics support.
  ColorLife.ASM provided as example of how to do graphics.

* Background user has full 63Kb user space, but cannot perform graphics.
  No access to keyboard; operates only from DO files.
  Also has access to CoCo I/O space, but should be used very carefully.
  Can be used as spooler.

* SDOS1.1H, SDOS/ES and drivers sit in 56Kb of their own.  Top 1Kb
  of all "banks" is common address space to allow transfers, etc.

* Last 128k is used as floppy disk/Winchester disk Big cache.
  Background user can be dropped to expand cache to 184k, or to make
  a semiconductor disk (system comes configured with Cache logic enabled).

* Floppy drivers support all configurations of floppy disks: doublesided,
  doubletrack, FLEX format, AMDEK; can be switched dynamically
  New drivers allow multiple writes/multiple verifies for enhanced performance.
  (this is done by cache logic).

* Supports RAG Winchester controller, J&M floppy/winchester controller,
  80 column card, CoCo serial port, RAG paralell port card.

* Can run FLEX Simulator

* Radio Shack BASIC modified to talk to disks/console via SDOS.
  Disconnects RSBASIC from raw hardware (allows FAST disk I/O,
  Winchester drive support, overlapped device I/O).
  Allows line editing via WRITEEDITLINE.

Ideal combination has 256Kb ram and floppy controller on one card.

Second possibility is 256Kb ram + Winchester interface.
