.ce
COCO SDOS
.ce
THE FUTURE FOR RADIO SHACK COLOR COMPUTER OPERATING SYSTEMS
.sp
The Radio Shack Color Computer is clearly a winner in the consumer computer
business. To ensure continued success for the Color Computer, Radio Shack must
provide it with evolutionary growth paths that give customers real solutions
(unlike the Commodore growth path). Such growth paths ensure that a customer
can buy the initial computer at very low cost (assuring its initial attraction
in the face of a bewildering array of potential vendors), and can expand the
computers's capability at modest cost when needed.  Thus, the customer is
satisfied, and Radio Shack is assured of his repeat business.
.sp
While disk drives and OS-9 provide some of the growth paths necessary, these
features will not be enough in long run, especially considering the
shortcomings of OS-9, its perception in the eyes of the users, and what the
competition offers.
.sp
This document discusses SDOS, a disk operating system, that runs on the Radio
Shack Color Computer, and how SDOS matches future trends for that market
place.  It compares SDOS with other operating systems available for the Color
Computer, and demonstrates the advantage to the consumer, and therefore to
Radio Shack.
.sp
WHAT CAN SDOS DO THAT IS NOT PRESENTLY AVAILABLE FOR A COCO?
.sp
Without going into details just yet, SDOS can provide the following
enhancements to Color Computers:
.sp
.in 5
Versatile, bug-free DOS that does not scare users (unlike OS-9, commands are
not cryptic, error messages are printed in English, simpler learning curve for
users because of consistent editing conventions, etc.)
.sp
An operating system that is extremely well documented (500+ pages on SDOS alone
--> smaller customer support)
.sp
Better use of machine resources (typeahead REALLY works, true disk
buffering, really fast BASIC programs that fit into computer better than
BASIC09, no false promises "OS-9 multitasking" or garden-path ideas
like "timeshareing a Coco" which simply disappoint)
.sp
128kb option that effectively uses the other 64kb (OS-9 cannot do this; stacks
up well against Apple IIc, gives 56Kb user RAM, even with 6K graphics hi-res
graphics buffer, SDOS lives in other bank with large disk buffer pool for
enhanced disk performance)
.sp
Efficient hard disk support
.sp
Can provide backwards compatability with RSBASIC (including hard disk support,
fast buffered I/O, etc.)
.sp
Can provide backwards compatability with foreign operating systems like FLEX
and MDOS.
.sp
Networking multiple CoCos is possible
.sp
.in 0
WHAT IS SDOS?
.sp
An "operating system" is a set of software that makes the raw hardware
easier to use.  The hardware resources that one would like to use are:
.sp
.in 10
* CPU cycles (computing energy)
.br
* Disk Storage (and retreival)
.br
* Display capability (text and graphics)
.br
* Data capture facilities (keyboard)
.br
* Hardcopy facilities (printers)
.in 0
.sp
SDOS is a disk operating system designed to efficiently manage the resources
available on a 6809-based microcomputer, using a friendly interface style.
.sp
SDOS automatically allocates CPU cycles to multiple tasks on a priority basis.
All the tasks in an SDOS system work together to accomplish the application
program's solution.  Tasks include terminal/printer management, timer
management, and the application program.
.sp
Disk space is automatically allocated to files as needed, and deallocated on
demand. All files are automatically sequential AND random access. File size is
kept to the byte; thus, no program can get data back out of a file that it did
not put into it (as with some sector based systems such as FLEX) Records are
not limited in size, and are not affect in any way by physical sector size or
boundaries; thus, an application program deals with data files identically
whether they are present on floppy disk drives or on Winchester disk drives.
Files are date-stamped with date of last modification, and marked by an
incremental backup program as "BACKED UP", so a user can keep track of the
latest versions of his programs and data. Files can be as large as the disk
(even with a Winchester), and can be as fragmented as required, although SDOS
always attempts to allocate a file contiguously.  In spite of file size and
possible fragmentation, random access to a file is guaranteed to take no more
than 2 disk reads. A disk buffer pool ensures efficient access to the disk by
use of automatic read-ahead when SDOS notices a program is performing
sequential access; this usually causes the next sector that a program might
want to be present in the buffer pool just when the program asks for it (an
example: the Assembler runs as a COMPUTE bound program; it never waits for the
disk!). The buffer pool also ensures that random accesses to a file AVERAGE
only a single disk read, by holding the critical access information in the disk
buffer pool. The directory on each drive is hashed, for average file open times
of 1 disk read. Data records can be of any size, and in particular, are not
limited to the sector size of the disk (as with FLEX).  SDOS can handle ANY
(mixture of) sector sizes, not just 256 bytes (as with OS-9), so SDOS can work
with Winchesters with large sector sizes, or with industry standard IBM 3740
format diskettes. Thus the disk file system provides fast and convenient files
for applications. All of this technical wizardry is hidden from the user; all
he sees is that "files store data", and he does not have to worry about all
sorts of complicated technological issues.
.sp
SDOS provides a VIRTUAL TERMINAL (VT) interface to display devices and
printers. This defines a device-independent method for handling the
bewildering array of terminals, keyboards and printers available.  The VT
interface defines standard methods for performing operations such as "clear
screen", "eject page", "position cursor", "newline", "background color",
"character features" (such as color, font, reverse, bold, blink, underline,
etc.). This ensures that an application program written to work with one
display device automatically works with another, without ANY changes to the
application program.
.sp
A graphics option is available that allows an application to draw
lines, circles, boxes, and arbitrary figures on a high-resolution display
screen.  The graphics options allows text interspersed with the graphics.
.sp
The data entry facilities are designed to make the operators life simple.
Single lines may be entered into application programs using a DELETE key
to correct mistakes, or to cancel an entire line.  Horizontal editing by
moving the cursor near an error and correcting by DELETE or inserting new
text is standard; thus a user may fix an error made early in line without
having to retype the line (try this once and you become a convert!).
The operator need only learn ONE style of data entry; all programs,
the operating system, and even the screen editor use this same editing style.
A special FIELD ENTRY mode provided by SDOS allows applications to define
fields on screen, and to let the operator fill in the fields in any order.
.sp
SDOS utility programs help users determine what files are stored on disks, what
is in a file, moving files around, formatting and initializing disk structures,
making absolutely trustworthy backups, and repairing damaged file structures.
Users may easily write their own utility programs in compiled BASIC.
.sp
SDOS also has (but not for a Color Computer) multi-user and networking options.
The Network option allows multiple computers to share each others' disk and
peripheral resources.
.sp
SOFTWARE TOOLS AVAILABLE FOR SDOS
.sp
A conventional text editor, assembler, and debugger are available as standard
tools for developing machine language applications under SDOS.
The simple SDOS interface to assembly language programs makes coding
even complex I/O transactions very easy (these tools are automatically included
as part of the CoCo SDOS package)
.sp
The method of choice for programming under SDOS is the SD BASIC compiler. The
compiler provides all the facilities needed by an application, including long
variable/label names, structured programming constructs, true subroutines and
functions with multiple arguments, string arrays, comprehensive
disk/terminal/printer I/O, decimal floating point arithmetic, error trapping,
etc.  For most of these facilities, a convenient notation is provided
directly by the language; a subroutine facility allows a user provide a
conventient notation for other mechanisms, thus simplifying coding and
maintainence of applications. The compiler produces very fast code to ensure
efficiency of execution (typical FOR-NEXT loops are 12 times as fast as
RSBASIC). Since the Runtime system is small, and the compiled applications are
extremely dense (statements like A=2 take only TWO bytes of memory), large
applications (50 source pages!) may be run even on a single user system. A
small sample BASIC program is included to demonstrate its style.
.sp
A full screen editor and word processing package are available.  The
editor requires a user learn ONLY 7 (takes about 5 minutes) for them
to start use; yet it includes facilities for string search, cut-and-paste,
power typing mode with automatic paragraph justification, and margins.
The word processing package handles paging, justification, table of
contents, indexing, and many more facilities expected of a versatile
word processor.
.pa
WHO IS AFRAID OF THE BIG BAD WOLF, OR WHAT DOES OS-9 DO POORLY?
.sp
SEE OS-9 DEFECT LIST THAT YOU GAVE TO RON!
.sp
OS-9 has all the earmarks of a nice operating system.
However, it fails to live up to its promise (based solely on its merits), and
is especially weak in the Color Computer environment.
.sp
To sell large numbers of disk-based systems, the consumers MUST be able to
use them. Unfortunately, OS-9 intimidates would-be users, precisely because it
is so "hi-tech". The power of OS-9 comes from being able to control
everything; this two edged-sword is also precisely its flaw
from the point of a user, who really wants the computer to do the "right thing"
without him thinking a lot about it.
.sp
In spite of the widespread availability of OS-9, many application programs
will not run on the CoCo due to its limited display and memory capacity.
Thus the "apparantly" large software base is not real.
.sp
The consumer also implicitly expects that as he expands his computer,
his old software will continue to work somehow.  Ideally, his old
software will work even better, in the sense it is more convenient to use
(because it can be loaded quickly from a disk), or it is faster.
This is true for virtually all mass-market micros (esp. Apples), since when
one gets a disk drive, the BASIC program one wrote can be save and run
directly from the drives. It is true also for Radio Shack Disk BASIC; what is
not true, is that the "advanced" software provided by Radio Shack (OS-9) will
meet the user's expectation in this area; for him, OS-9 is a giant step
backwards!
.sp
Worse yet, the commands used by OS-9 look like so much gobbledygook to
a novice.  Consider <choose an ugly example>: can you even read it?
The corresponding commands under SDOS are: <nice example>.
OS-9s arcane command style is compounded by their hard-to-read manual
and by the (shudder!) NUMERIC error numbers one gets when a mistake
is made.
.sp
All of the multitasking facilities of OS-9 are only so much static to
the ears of most novices. Not only can they not understand what the
multitasking facilties do, but even if they understood, their power
cannot be realized on a CoCo due to limitations in memory and the
economic disadvantage of attaching terminals to a CoCo, not to mention
the absence of places to attach them.
Since the CoCo IS a terminal,
timesharing a Color Computer has got to be one of the stupidest ideas on the
face of this planet; yet that is how the "utility" of multitasking
is explained to the users.

.sp
OS-9 cannot handle 128Kb installed in an economical fashion in the CoCo.
First, there are two flavors of OS-9: OS-9 level I, and OS-9 level II.
Level 1 will work in CoCos with a maximum of 64K.  Level II will
will not work in computers with less than 128K, and it requires a special
hardware to accomplish a memory management technique known as "dynamic address
translation". This requirement is wired so deeply into OS-9 that it cannot be
removed. Memory management does not exist in the CoCo now, and probably cannot
be added in a practical fashion either as a retrofit to machines in the field,
or in a new design because of the costs involved; even if it could,
the licensing costs of OS-9 level two would probably make the combination
unattractive.
Thus OS-9 cannot carry the CoCo into a 128K configuration.
(SDOS/ES easily handles 128K with simple bankswitching).
.sp
OS-9 cannot handle networking.  There never has been any network support
for OS-9, and Microware (OS-9's designer) shows no interest in such
a subject.  This will be a severe disadvantage in school marketplaces
in the future (SDOS has a network option; it can even use RS232 ports
to make a reasonable network).
.sp
OS-9 does not really handle advanced features such as typeahead. Typeahead is
the ability to type commands to the computer, even when it is busy doing
something else, and be assured that what you typed was heard and will be acted
upon as soon as possible. People doing any sort of editing, especially word
processing, invariably complain when typeahead is not present.  While OS-9 does
provide a weak implementation (you can type ahead IF THE DISKS ARE NOT
SPINNING), in practice, one cannot know when the disk are about to start
spinning, and so one cannot typeahead reliably. The result: nobody types ahead.
Thus we find the person waiting for the computer, instead of the other way
around, and yet the computer is supposed to be the helper.
(SDOS handles typeahead even when the disk is spinning).
.sp
OS-9 does not handle the problem of disk space allocation well. While it is not
a problem on floppy disks, growth to Winchesters is inevitable.  On a long-used
Winchester, all the disk space one needs for some new file may not be available
in one chunk on the disk, so some mechanism for handling "fragmented
allocation" is necessary. While OS-9 can handle some fragmentation, severe
fragmentation on a long-used disk can prevent OS-9 from creating a file even
though enough disk space is available. Can you imagine explaining to user that
he has enough disk space, but the Operating System (remember, that's the thing
that makes the computer easy to use?) can't figure out how to handle it?
(SDOS can ALWAYS make the file, no matter how badly the disk is fragmented.
But SDOS also knows that disk "fragmented allocation" also limits
performance, and tries very hard to allocate disk space to files
to minimize such fragmentation; thus, even long-used disks under
SDOS still end up with "nicely" allocated, and thus "nicely" performing
files).
.sp
OS-9 cannot provide backward compatibility.  Users, having spent much
time learning how to operate RSBASIC, must abandon all thought of it
to use OS-9.  Their first reaction: "What a waste! Why bother?"
Thus the number of OS-9 systems sold is diminished, and the
CoCo market fragments into the OS-9ers and the rest.
(RSBASIC could easily be modified to run under SDOS, thus providing
backwards compatibility, and even expansion of RSBASIC to the point
of being able to efficiently handle Winchester disk files! This is
possible because the disk access mechanisms are in the operating system,
not BASIC.  With everybody able to run RSBASIC, the market is
not so fragmented, more SDOS's are sold, and the software base
can grow twice as fast since everybody is pulling in the same direction).
.sp
OS-9 does not "perform" well.  Good performance requires careful design of
buffering schemes to ensure that the computer can continue working even if a
slow device is not yet done.  While OS-9 does do some buffering of printer
output, there is absolutely no disk buffering whatsoever! When the disks are
spinning, OS-9 is "frozen" and can do no I/O whatsoever! The result: reading
sequential files (this includes loading programs) is VERY slow, and output to
printers stop while the disk is running. Again, the Operating System is
supposed to HELP, not hinder. (SDOS provides a disk buffer pool, automatically
reads ahead on sequential files, and buffers all of its device I/O for
efficient operation).
.sp
OS-9 documentation is thin.  SDOS by itself has over 500 pages, and
while this may seem overwhelming, it is complete with table of contents and
indexes to help customers.  The information available minimizes customer
aggravation and the number of phone calls to the vendor.
.sp
THE APPLE FACTOR
.sp
It is our perception that everbody who buys a Color Computer knows essentially
what an Apple II computer is.  Thus, the Apple II, while not price competitive
at the time of original purchase by the customer, will be used by the customer
as a standard for comparision. (In spite of the emphasis in this section, one
should not assume that the discussion in this document focuses only on the
relation of CoCos to Apples).
.sp
Apple IIs sell well because they can be used to play games that draw pretty
pictures, solve problems (i.e., simple word processing), and they
have an immense amount of software available.  These features of an Apple
are what the consumer understands.  What he does NOT understand is the true
impact of the technical architecture of the computer; all he hears about this
is some hi-tech jargon about RAM, ROM, Hard Disk, Graphics, Networking, etc.
Faced with the problem of buying a computer, he will thus make his choice
based on what he does understand, and what he has heard is a "good thing".
.sp
The popular Apple sold today is the Apple IIc, which has 128Kb of RAM,
Graphics, an available DOS, hard disk drives (check accuracy!), networking
and BASIC.  Knowing that Apples have these "technical characteristics",
some natural comparisons will be drawn when the consumer goes to make
a purchase: does (or can it be added later) the computer under consideration
have these same technical characteristics?  If the answer is no,
the chance of making a sale drops, not because of the actual need
of the consumer for these technical characteristics, but simply because
the "other product" is "better".
.sp
The implications are clear: the CoCo should have options which provide
all of the "technical characteristics" provided by an Apple II.  This
can be accomplished two ways:  provide a weak implementation of
the "technical characteristic", or provide a strong implementation.
A weak implementation is one which provides the features in a trivial
form only; a strong implementation is one which solves the problem in a
flexible fashion.
.sp
Strong implementations are the best if they can be provided economically,
based on the philosophy of "Sell the customer what he WANTS (the
buzzword), and make sure it contains what he NEEDS (or at least it works
very well), and you will have a satisfied customer". Thus, ideally,
one would like to have, when comparing to an Apple, 128Kb of RAM
which is really useful, a useful DOS, a hard disk option, real networking,
and a nice BASIC.
.sp
A typical example of a weak implementation is what is now being sold by the
CoCo aftermarket 128K option vendors.  These vendors provide the CoCo with a
true 128k, but this memory CANNOT be used by a single program to accomplish its
purposes in any meaningful way.  The customer will not long be deceived. Weak
implementations will serve initial marketing purposes: getting the customer to
buy the machine. But they violate the philosophy of "...make sure it contains
what he NEEDS", with the probable consequence that word will eventually get
out, and impact sales.
.sp
SDOS can provide strong implementations of all of the above, at very
economical costs, thus making the comparision of the Color Computer to an
Apple come out favorably, and avoiding the long-term deficiencies of weak
implementations.  Past experience with SDOS has shown that customers are
generally very happy with the system because it really does provides what
they need.
.sp
EXCEPTIONAL FEATURES OF SDOS NOT ALREADY MENTIONED
.sp
Every user owning a computer will sooner or later damage a diskette
electronically; this happens because of operator error, power blinks, or
program bugs.  When this happens, most diskettes contain valuable data which
the user would like to recover, but cannot because the electronic damage has
mangled something critical to the operating system's ability to recover that
data.  With most DOS's, the user is out of luck at this stage.  With a
Winchester disk drive, this is virtually a disaster! Not so with SDOS; most
disk data structures are either duplicated or are stored in some redundant
fashion, so when one structure is damaged, another provides enough information
to get around the damage.  A special program, SDOSDISKVALIDATE, checks out SDOS
diskettes, complains if something about them is not right, and offers the user
a variety of ways to repair the problem. SDOSDISKVALIDATE is almost always able
to repair the problem. Even if it is not possible to repair the disk
structures, the SDOSDISKBACKUP program can be used to recover the raw data on a
disk, even in the presence of hard disk read errors. Finally, lost files can be
recovered using the RECOVERFILES utility.
.sp
Networking provides a means whereby one computer can access files on another
computer as though those files were present on a local disk drive. Joe's
application programs can access files on Fred's computer merely by referring to
the desired file as FRED:XYZ instead of simply XYZ. That's it! The networking
software handles all the complications and aggravations of ensuring that
accesses to FRED:XYZ happen EXACTLY as if XYZ were local.  A major advantage is
that application programs DO NOT NEED TO BE CHANGED to use a remote file or
device.
.sp
User friendliness is all important when dealing with novice or infrequent
computer users.  SDOS spells out all command names instead of using cryptic
notations.  Error messages are printed in English.  Typeahead really works.
The system is fast, and the documentation thorough.  These features are
all designed to make the user feel comfortable with the computer.
.sp
CURRENT STATUS OF SDOS
.sp
SDOS has been under development and in daily field use since 1979, and thus
has a proven record of reliable operation.
.sp
SDOS (SDOS/SU) is currently available for CoCos with 64Kb and one or more disk
drives. (see enclosed literature).  It already provides efficient,
interrupt-driven and buffered I/O, including full keyboard typeahead, even
when the disks are spinning (unlike OS-9).  Tools included are utilities,
editor, assembler, and debugger; optionally available are the BASIC Compiler,
an ISAM file package, a full-screen text editor and word processing package,
a Wire-Wrap design program, and a graphics support package.
.sp
Like OS-9, a 64Kb memory space has a tendency to be cramped when one places
the operating system and the user's program in the machine. This is alleviated
by versions of SDOS that use bank-switching (avoiding the complications and
expense of Memory Management hardware) to provide up to 63Kb of user space in
one bank, with the operating system components in (an)other bank(s). Versions
of SDOS operate in commercially available micros in multi-user mode (SDOS/MT),
and in 128kb single user mode (SDOS/ES).  While we don't expect SDOS/MT to be
made available for CoCos, SDOS/ES would need to be installed to provide a
128Kb option.  This, in turn, requires a 128Kb option card (an additional
64kb) to be designed and implemented for the CoCo; the 128kb cards available
from sundry vendors are perhaps workable but unnecessarily clumsy
because of minor (stupid!) design faults due to the short-sightedness of the
designers. SD can design and implement a prototype card for Radio Shack in a
very short period of time; likewise, SD can install SDOS/ES relatively quickly
once the 128kb option is ready.
.sp
SDOS/ES, with its 128kb user space, opens the door to backwards compatability
with RSBASIC, wider availablity of tools (via MDOSSIM and FLEXSIM)
and Networking (by making room for the SDNET modules required).
.sp
Our analysis shows that interfacing RSBASIC to SDOS would be relatively
simple; essentially, we throw away about 1/2 of the DISKBASIC ROMs,
while leaving the balance of BASIC essentially intact.  Doing this
provides one with RSBASIC that operates under the aegis of SDOS, thus
acquiring all the buffering, interrupt handling, and floppy AND hard disk
management, with no change to user programs!  Thus we acquire backward
compatability.  Under SDOS/ES, the BASIC interpreter could actually
be moved somewhat higher in memory, due to the shrinkage of the disk
"ROMS" and the minimal demands by SDOS/ES on the memory of an application
program; thus users could also derive the benefit of even larger
program areas.
.sp
We have implemented a package to simulate MDOS (Motorola's 6809 development
system) under SDOS.  This package allows us to run Motorola MDOS software
WITHOUT ANY CHANGES directly under SDOS (we even read their disk formats),
including assemblers, FORTRAN and PASCAL compilers, etc.
The FLEX operating system also has a wide availability of development tools,
such as PASCAL, COBOL, C, etc. which SDOS currently lacks.
Work is similarly underway now to allow FLEX programs to run UNCHANGED under
SDOS.
.sp
SD is shipping Network modules to allow multiple 6809 microcomputers to
communicate as though remote files and devices were local.  A specialized
physical link driver has already been implmented that can run error-free
transactions over (even noisy) RS232 serial links such as that provided by the
Radio Shack Modem cartridge at up to 19.2Kbaud; at reasonable baud rates, such
a network works surprisingly well.  Such a network should be quite interesting
in schools, especially if one the nodes is armed with a hard disk. We don't
know if we can successfully use the RS232 port built into the CoCo for this
purpose; in an interrupt-driven environment, we expect is answer is NO
unless severe limits on the baud rate are made, which have a deleterious
effect on network performance.
.sp
These modules
can be placed into the Operating System bank of a 128Kb CoCo
.sp
WHAT'S IN IT FOR US?
.sp
What is SD's motivation for making this proposal?  We believe that
we cannot effectively sell our products into a mass marketplace
without the distribution system that Radio Shack has.  We (selfishly)
would like to make a bundle of money (a nickel at time is fine
with us, thank you) on our investment in our software, and we
don't mind if someone else makes a nickel too.
.sp
We are interested in a royalty arrangement, probably with SD providing
all the technical support required for product preparation and
delivery.
