DVTYP.CONSOLE   RMB     1       CONSOLE (HUMAN'S INTERFACE)
*       WHAT FOLLOWS IS LIFTED FROM THE "MDOS" MANUAL
*       **** SYSTEM EQUATE FILE **** FOR MDOS

*
*       MDOS VERSION 2.01 -- SYSTEM EQUATE FILE -- APRIL 29,1977
*
*       DEFINE MULTI-SECTOR/SINGLE SECTOR I/O
*
MULTS   EQU     0       0 => SINGLE SECTOR, 1=> MULTIPLE SECTOR

*       SKIP2, SKIP1, SCALL, UCALL, SEQ MACROS INTENTIONALLY LEFT OUT
*
SCALL   EQU     $3F             SYSTEM CALL
*
*       S Y S T E M   F U N C T I O N   D E F I N I T I O N S
*
*
*       SET LOCATION COUNTER TO 0 FOR THE EQUATE DEFINITIONS
*
:SAV    SET     *               SAVE OLD LOCATION COUNT
        ORG     $0
*
*
*
.RESRV  RMB     1               .RESERVE A DEVICE
.RELES  RMB     1               .RELEASE A DEVICE
.OPEN   RMB     1               .OPEN A FILE
.CLOSE  RMB     1               .CLOSE A FILE
.GETRC  RMB     1               .READ A RECORD
.PUTRC  RMB     1               .WRITE A RECORD
.REWND  RMB     1               .POSITION TO BEGINNING OF FILE
.GETLS  RMB     1               .READ LOGICAL SECTOR
.PUTLS  RMB     1               .WRITE LOGICAL SECTOR
.KEYIN  RMB     1               .CONSOLE INPUT
.DSPLY  RMB     1               .CONSOLE OUTPUT (TERM W/ CR)
.DSPLX  RMB     1               .CONSOLE OUTPUT (TERM W/ EOT)
.DSPLZ  RMB     1               .CONSOLE OUTPUT (TERM W/ EOT, NO CR/LF AT END)
.CKBRK  RMB     1               .CHECK CONSOLE FOR BREAK KEY
.DREAD  RMB     1               .EROM DISK READ
.DWRIT  RMB     1               .EROM DISK WRITE
.MOVE   RMB     1               .MOVE A STRING
.CMPAR  RMB     1               .COMPARE STRINGS
.STCHB  RMB     1               .STORE BLANKS
.STCHR  RMB     1               .STORE CHARACTERS
.ALPHA  RMB     1               .CHECK ALPHABETIC CHARACTER
.NUMD   RMB     1               .CHECK DECIMAL DIGIT
.ADDAM  RMB     1               .INCREMENT MEMORY (DOUBLE BYTE) BY A
.SUBAM  RMB     1               .DECREMENT MEMORY (DOUBLE BYTE) BY A
.MMA    RMB     1               .MULTIPLY (SHIFT LEFT) MEMORY BY A (COUNT)
.DMA    RMB     1               .DIVIDE (SHIFT RIGHT) MEMORY BY A (COUNT)
.MDENT  RMB     1               .ENTER MDOS WITHOUT RELOADING
.LOAD   RMB     1               .LOAD A FILE FROM DISK
.DIRSM  RMB     1               .DIRECTORY SEARCH AND MODIFY
.PFNAM  RMB     1               .PROCESS FILE NAME
.ALUSM  RMB     1               .ALLOCATE USER MEMORY
.CHANG  RMB     1               .CHANGE NAME/ATTRIBUTES
.MDERR  RMB     1               .MDOS ERROR MESSAGE HANDLER
.ALLOC  RMB     1               .ALLOCATE DISK SPACE
.DEALC  RMB     1               .RETURN DISK SPACE
.EWORD  RMB     1               .SET ERROR STATUS WORD FOR CHAIN
.TXBA   RMB     1               .TRANSFER X TO B,A
.TBAX   RMB     1               .TRANSFER B,A TO X
.XBAX   RMB     1               .EXCHANGE B,A AND X
.ADBX   RMB     1               .ADD B TO X
.ADAX   RMB     1               .ADD A TO X
.ADBAX  RMB     1               .ADD B,A TO X
.ADXBA  RMB     1               .ADD X TO B,A
.SUBX   RMB     1               .SUBTRACT B FROM X
.SUAX   RMB     1               .SUBTRACT A FROM X
.SUBAX  RMB     1               .SUBTRACT B,A FROM X
.SUXBA  RMB     1               .SUBTRACT X FROM B,A
.CPBAX  RMB     1               .COMPARE B,A TO X
.ASRX   RMB     1               .SHIFT X RIGHT (ARITHMETIC)
.ASLX   RMB     1               .SHIFT X LEFT (ARITHMETIC/LOGICAL)
.PSHX   RMB     1               .PUSH X ON STACK
.PULX   RMB     1               .PULL X FROM STACK
.PRINT  RMB     1               .PRINT-TERMINATE WITH CR
.PRINX  RMB     1               .PRINT-TERMINATE WITH EOT
.GETFD  RMB     1               .READ FDR
.PUTFD  RMB     1               .WRITE FDR
.PUTEF  RMB     1               .WRITE EOF
.EREAD  RMB     1               .DISK READ W/ ERR RETN
.EWRIT  RMB     1               .DISK WRITE W/ ERR RETN
        RMB     1
        RMB     1
        RMB     1
        RMB     1
.BOOT   RMB     1               .RELOAD MDOS

        ORG     :SAV            RESTORE LOACTION COUNTER
*
*
*       A S C I I   C O N T R O L   C H A R A C T E R S
*
NULL    EQU     0               NULL
SOH     EQU     1               START OF HEADING
STX     EQU     2               START OF TEXT
ETX     EQU     3               END OF TEXT
EOT     EQU     4               END OF TEXT
ENQ     EQU     5               ENQUIRY (WRU- WHO ARE YOU)
ACK     EQU     6               ACKNOWLEDGE
BEL     EQU     7               BELL
BS      EQU     8               BACKSPACE
HT      EQU     9               HORIZONTAL TAB
LF      EQU     $A              LINE FEED
VT      EQU     $B              VERTICAL TAB
FF      EQU     $C              FORM FEED
CR      EQU     $D              CARRIAGE RETURN
SO      EQU     $E              SHIFT OUT
SI      EQU     $F              SHIFT IN
DLE     EQU     $10             DATA LINK ESCAPE
DC1     EQU     $11             DEVICE CONROL 1
DC2     EQU     $12             DEVICE CONTROL 2
DC3     EQU     $13             DEVICE CONROL 3
DC4     EQU     $14             DEVICE CONTROL 4
NAK     EQU     $15             NEGATIVE ACKNOWLEDGE
SYN     EQU     $16             SYNCHRONOUS IDLE
ETB     EQU     $17             END OF TRANSMISSION BLOCK
CAN     EQU     $18             CANCEL
EM      EQU     $19             END OF MEDIUM
SUB     EQU     $1A             SUBSTITUTE
ESC     EQU     $1B             ESCAPE
FS      EQU     $1C             FISLE SEPERATOR
GS      EQU     $1D             GROUP SEPERATOR
RS      EQU     $1E             RECORD SEPERATOR
US      EQU     $1F             UNIT SEPERATOR
SPACE   EQU     $20             SPACE (WORD SEPERATOR)
RUBOUT  EQU     $7F             DELETE (RUBOUT)
*
*       S P E C I A L   C H A R A C T E R    E Q U A T E S
*
SUFDLM  EQU     '.              SUFFIX DELIMITER
OPTDLM  EQU     ';              OPTIONS DELIMITER
DRVDLM  EQU     ':              LOGICAL DRIVER DELIMITER
DEVDLM  EQU     '#              GENERIC DEVICE NAME DELIMITER
FAMDLM  EQU     '*              FAMILY NAME/SUFFIX DELIMITER
E$FATL  EQU     1##7            FATAL ERROR BIT
        PAGE
*
*       M D O S   S E C T O R    E Q U A T E S
*
SC$DID  EQU     0               DISK ID PHYSICAL SECTOR NUMBER
SC$CAT  EQU     1               CLUSTER ALLOCATION TABLE PHYSICAL SECTOR NUMBER
SC$LOK  EQU     2               LOCKOUT CLUSTER TABLE PHYSICAL SECTOR NUMBER
SC$DIR  EQU     3               DIRECTORY START PHYSICAL SECTOR NUMBER
SC$DRE  EQU     $16             DIRECTORY END PHYSICAL SECTOR NUMBER
SC$BB   EQU     $17             BOOT BLOCK PHYSICAL SECTOR NUMBER
SC$DOS  EQU     $18             OPERATING SYSTEM PHYSICAL SECTOR NUMBER (RIB ADDRESS)
SC$SIZ  EQU     128             SECTOR SIZE IN BYTES
SC$TRK  EQU     $26             NUMBER OF SECTORS / TRACK
SC$CLS  EQU     4               NUMBER OF SECTORS / CLUSTER
SC$MAX  EQU     2000            MAXIMUM NUMBER OF USABLE SECTORS
DFCLS$  EQU     32              DEFAULT NUMBER OF CLUSTERS
*
*       D I S K    I D    S E C T O R    O F F S E T S
*
DID$ID  EQU     0               OFFSET TO DISK ID (8 BYTES)
DID$VN  EQU     8               OFFSET TO VERSION NUMBER (2 BYTES)
DID$RN  EQU     10              OFFSET TO REVISION NUMBER (2 BYTES)
DID$DT  EQU     12              OFFSET TO DATE (6 BYTES)
DID$NM  EQU     18              OFFSET TO USER NAME (20 BYTES)
DID$RB  EQU     38              OFFSET TO RIB ADDRESS (20 BYTES)
*
*       D I R E C T O R Y    E N T R Y    O F F S E T S
*
DIR$NM  EQU     0               OFFSET TO NAME (8 BYTES)
DIR$SX  EQU     8               OFFSET TO SUFFIX (2 BYTES)
DIR$RB  EQU     10              OFFSET TO RIB ADDRESS
DIR$AT  EQU     12              OFFSET TO ATTRIBUTES (2 BYTES)
DIR$NU  EQU     14              OFFSET TO NOT USED AREA (2 BYTES)
*
*       R I B    B I N A R Y    F I L E    O F F S E T S
*
RIB$LB  EQU     117             NUMBER OF BYTES IN LAST SECTOR
RIB$SL  EQU     118             NUMBER OF SECTORS TO LOAD
RIB$LA  EQU     120             MEMORY LOAD ADDRESS
RIB$SA  EQU     122             START EXECUTION ADDRESS
        PAGE
*       U N I F I E D    I / O    C O N T R O L    B L O C K
*
*               O F F S E T S
*
IOCSTA  EQU     0               ERROR STATUS
IOCDTT  EQU     1               DATA TRANSFER TYPE
IOCDBP  EQU     2               DATA BUFFER POINTER
IOCDBS  EQU     4               DATA BUFFER START ADDRESS
IOCDBE  EQU     6               DATA BUFFER END ADDRESS
IOCGDW  EQU     8               GENERIC DEVICE TYPE/CONTROL DESCRIPTOR ADDRESS
IOCLUN  EQU     10              LOGICAL UNIT NUMBER
IOCNAM  EQU     11              FILE NAME
IOCMLS  EQU     11              MAXIMUM REFERENCED LOGICAL SECTOR NUMBER
IOCSDW  EQU     13              CURRENT SEGMENT DESCRIPTOR WORD
IOCSLS  EQU     15              1ST LOGICAL SECTOR OF CURRENT SEGMENT
IOCLSN  EQU     17              CURRENT LOGICAL SECTOR NUMBER
IOCSUF  EQU     19              FILE NAME SUFFIX
IOCEOF  EQU     19              LOGICAL END OF FILE
IOCRIB  EQU     21              PHYSICAL DISK ADDRESS OF RIB
IOCFDF  EQU     23              FILE DESCRIPTOR FLAGS
IOCDEN  EQU     27              DIRECTORY ENTRY NUMBER
IOCSBP  EQU     29              SECTOR BUFFER POINTER/INITIAL ALLOCATION
IOCSBS  EQU     31              SECTOR BUFFER START ADDRESS
IOCSBE  EQU     33              SECTOR BUFFER END ADDRESS
IOCSBI  EQU     35              SECTOR BUFFER INTERNAL PTR
IOCBLN  EQU     IOCSBI+2-IOCSTA IOCB LENGTH
*
*       U N I F I E D    I / O    E R R O R    S T A T U S E S
*
:SAV    SET     *               REMEMBER THE CURRENT LOCATION COUNTER
        ORG     $0              RESET IT TO ZEROT TO USE THE SEQ MACKR
*
I$NOER  RMB     1               NO ERRORS, NORMAL RETURN
I$NODV  RMB     1               NO SUCH DEVICE
I$RESV  RMB     1               DEVICE RESERVED ALREADY
I$NORV  RMB     1               DEVICE NOT RESERVED
I$NRDY  RMB     1               DEVICE NOT READY
I$IVDV  RMB     1               INVALID DEVICE
I$DUPE  RMB     1               DUPLICATE FILE NAME
I$NONM  RMB     1               FILE NAME NOT FOUND
I$CLOS  RMB     1               FILE NAME NOT OPEN/ OR FILE NOT CLOSED
I$EOF   RMB     1               END OF FILE
I$FTYPE RMB     1               INVALID FILE TYPE
I$DTYP  RMB     1               INVALID DATA TRANSFER TYPE
I$EOM   RMB     1               END OF MEDIA
I$BUFO  RMB     1               BUFFER OVERFLOW
I$CKSM  RMB     1               CHECKSUM ERROR
I$WRIT  RMB     1               FILE IS WRITE PROTECTED
I$DELT  RMB     1               FILE IS DELETE PROTECTED
I$RANG  RMB     1               LOGICAL SECTOR NUMBER OUT OF RANGE
I$FSPC  RMB     1               NO DISK FILE SPACE AVAILABLE
I$DSPC  RMB     1               NO DIRECTORY SPACE AVAILABLE
I$SSPC  RMB     1               NO SEGMENT DESCRIPTOR SPACE AVAILABLE
I$IDEN  RMB     1               INVALID DIR. ENTRY NO.
I$RIB   RMB     1               INVALID RIB
I$DEAL  RMB     1               CAN'T DEALLOCATE ALL SPACE
I$RECL  RMB     1               BINARY RECORD LENGTH TOO LARGE

        ORG     :SAV            RESTORE THE LOCATION COUNTER
        PAGE
*
*       M D O S    I N T E R N A L    V A R I A B L E S
*
*               A N D    L O C A T I O N    E Q U A T E S
*
MDOS$   EQU     $100            START OF MDOS ASECT
CBUFL$  EQU     80              COMMAND BUFFER LENGTH
CBUFF$  EQU     MDOS$-CBUFL$-2  COMMAND BUFFER LOCATION
CBUFP$  EQU     CBUFF$+CBUFL$   COMMAND BUFFER SCAN POINTER
VERS$$  EQU     MDOS$           VERSION #
REVS$$  EQU     VERS$$+2        REVISION #
KYI$SV  EQU     REVS$$+2        SAVE AREA FOR KEYIN$ VECTOR
ENDOS$  EQU     KYI$SV+2        END OF MDOS
ENDUS$  EQU     ENDOS$+2        END OF USER PROGRAM AREA
ENDSY$  EQU     ENDUS$+2        END OF SYSTEM (MDOS) RAN
RIBBA$  EQU     ENDSY$+4        RIB BUFFER ADDRESS
ENDRV$  EQU     RIBBA$+2        END OF MDOS ROM VARIABLES
GDBA$   EQU     ENDRV$+2        GENERIC DEVICE TABLE ADDRESS
SYERR$  EQU     GDBA$+2         SYSTEM ERROR STATUS WORD
SWI$SV  EQU     SYERR$+2        SWI VECTOR SAVE AREA
SWI$UV  EQU     SWI$SV+2        SWI USER VECTOR
IRQ$UV  EQU     SWI$UV+2        IRQ USER VECTOR
IRQ$SV  EQU     IRQ$UV+2        IRQ VECTOR SAVE AREA
CHFLG$  EQU     IRQ$SV+2        CHAIN FUNCTION FLAG WORD
SYIOCB  EQU     CHFLG$+2        CHAIN FUNCTION FLAG WORD
SYPOCB  EQU     SYIOCB+IOCBLN   SYSTEM PRINTER IOCB
SYEOCB  EQU     SYPOCB+IOCBLN   ERR MSG FILE
        PAGE
*
*       L O G I C A L    U N I T    N U M B E R  --   B I T    D E F I N I T I O N S
*
LU$RES  EQU     %01000000       IOCB RESERVED FLAG
*
*       I O C D T T  --  B I T   D E F I N I T I O N S
*
DT$OPP  EQU     %00000000       OPEN UPDATE/INPUT
DT$OPI  EQU     %00000001       OPEN INPUT MODE
DT$OPO  EQU     %00000010       OPEN OUTPUT MODE
DT$OPU  EQU     %00000011       OPEN UPDATE MODE
DT$NFF  EQU     %00000100       NON-FILE FORMAT I/O FLAG
DT$TRU  EQU     %00001000       TRUNCATE FLAG
DT$CLS  EQU     %00010000       FILE OPEN/CLOSE FLAG
DT$SIO  EQU     %00100000       SECTOR I/O FLAG
DT$OUT  EQU     %01000000       OUTPUT TRANSFER TYPE
DT$INP  EQU     %10000000       INPUT TRANSFER TYPE
*
*       I O C F D F  --  B I T    D E F I N I T I O N S
*
FD$FMU  EQU     %00000000       USER DEFINED FORMAT (SECTOR I/O ONLY)
FD$FMD  EQU     %00000001       DEFAULT OBJECT REC'D FORMAT (DEVICE DEPENDENT)
FD$FML  EQU     %00000010       BINARY LOAD FORMAT -- ABSOLUTE MEMORY IMAGE
FD$FMB  EQU     %00000011       BINARY RECORD FORMAT -- RASM OUTPUT, RLOAD INPUT
FD$FMR  EQU     %00000100       BINARY LOAD FORMAT -- RELOCATABLE MEMORY IMAGE
FD$FMA  EQU     %00000101       ASCII RECORD FORMAT -- INCLUDES EXORCISOR LOAD FORMAT
FD$FMC  EQU     %00000111       ASCII-CONVERTED-BINARY RECORD FORMAT
FD$CMP  EQU     %00001000       SPACE COMPRESSION FLAG
FD$CON  EQU     %00010000       CONTIGUOUS ALLOCATION FLAG
FD$SYS  EQU     %00100000       SYSTEM FILE ATTRIBUTE
FD$DEL  EQU     %01000000       DELETE PROTECTION ATTRIBUTE
FD$WRT  EQU     %10000000       WRITE PROTECTION ATTRIBUTE
*
*       U N I F I E D    I / O    C O N T R O L    D E S C R I P T O R
*
*               B L O C K    O F F S E T S
*
CDBIOC  EQU     0               ADDRESS OF IOCB
CDBSDA  EQU     2               SOFTWARE DRIVER ADDRESS
CDBHAD  EQU     4               HARDWARE ADDRESS
CDBDDF  EQU     6               DEVICE DESCRIPTOR FLAGS
CDBVDT  EQU     7               VALID DATA TYPE
CDBDDA  EQU     8               DEVICE DEPENDENT AREA
CDBWST  EQU     10              WORKING STORAGE
*
*       C D B D D F  --  B I T    D E F I N I T I O N S
*
DD$FMC  EQU     %00000001       ASCII-CONVERTED-BINARY IS DEFAULT OBJECT RECORD
DD$LOG  EQU     %00000010       LOGICAL SECTOR I/O FLAG
DD$CNS  EQU     %00000100       CONSOLE FLAG
DD$RWD  EQU     %00001000       REWIND FLAG
DD$OCF  EQU     %00010000       OPEN/CLOSE FLAG
DD$INP  EQU     %00100000       INPUT DEVICE FLAG
DD$OUT  EQU     %01000000       OUTPUT DEVICE FLAG
DD$RES  EQU     %10000000       RESERVABLE DEVICE FLAG
*
*       C D B V D T  --   B I T   D E F I N I T I O N S
*
VD$BIN  EQU     %00000100       BINARY OBJECT FLAG
VD$GDB  EQU     %00001000       TEMP GDB POINTER FLAG
VD$SDA  EQU     %00010000       TEMP SDA POINTER FLAG
VD$NFF  EQU     %10000000       NON-FILE FORMAT FLAG
*
*       D E V I C E    D R I V E R    E N T R Y    O F F S E T S
*
DV$ON   EQU     0               DEVICE ON OFFSET
DV$OFF  EQU     3               DEVICE OFF OFFSET
DV$INT  EQU     6               DEVICE INITIALIZATION OFFSET
DV$TRM  EQU     9               DEVICE TERMINATION OFFSET
DV$IO   EQU     12              DEVICE CHARACTER INPUT/OUTPUT OFFSET
        PAGE
*
*       D I S K    E R O M    E Q U A T E S
*
CURDRV  EQU     0               CURRENT DRIVE NUMBER
STRSCT  EQU     1               STARTING PHYSICAL SECTOR NUMBER
NUMSCT  EQU     3               NUMBER OF SECTORS TO OPERATE UPON
LSCTLN  EQU     5               NUMBERR OF BYTES TO BE READ FROM LAST SECTOR
CURADR  EQU     6               MEMORY ADDRESS FOR DISK TRANSFER
FDSTAT  EQU     8               DISK TRANSFER STATUS
SCTCNT  EQU     11              SECTOR COUNT USED IN DETERMINING ERRORS
PGMDRV  EQU     $1D             DRIVE FROM WHICH LAST PROGRAM WAS LOADED
PGMPSN  EQU     $1E             PHYSICAL SECTOR NUMBER OF RIB OF LAST LOAD PROGRAM
*
*       E R O M    E N T R Y    P O I N T S
*
OSLOAD  EQU     $E800           BOOTSTRAP THE OPERATING SYSTEM
FDINIT  EQU     $E822           INITIALIZE THE DISK'S PIA AND SSDA
CHKERR  EQU     $E853           CHECK AND PRINT ERROR FROM FDSTAT
PRNTER  EQU     $E85A           PRINT ERROR FROM FDSTAT
READSC  EQU     $E869           READ SECTOR(S)
READPS  EQU     $E868           READ PARTIAL SECTOR
RDCRC   EQU     $E86F           READ AND CHECK FOR CRC
RWTEST  EQU     $E872           READ/WRITE TEST
RESTOR  EQU     $E875           MOVE HEAD TO TRACK 0
SEEK    EQU     $E878           POSITION HEAD TO TRACK OF "STRSCT"
WRTEST  EQU     $E87B           WRITE TEST
WRDDAM  EQU     $E87E           WRITE DELETED DATA MARK
WRVERF  EQU     $E881           WRITE AND VERIFY CRC
WRITSC  EQU     $E884           WRITE SECTOR(S)
*
*       E R O M    E R R O R    E Q U A T E S
*
ER$CRC  EQU     '1              DATA CRC ERROR
ER$WRT  EQU     '2              WRITE PROTECTED DISK
ER$RDY  EQU     '3              DISK NOT READY
ER$MRK  EQU     '4              DELETED DATA MARK ENCOUNTERED
ER$TIM  EQU     '5              TIMEOUT
ER$DAD  EQU     '6              INVALID DISK ADDRESS
ER$SEK  EQU     '7              SEEK ERROR
ER$DMA  EQU     '8              DATA ADDRESS MARK ERROR
ER$ACR  EQU     '9              ADDRESS MARK CRC ERROR
*
*       M I S C E L L A N E O U S    E R O M    E Q U A T E S
*
RETRY$  EQU     5               RETRY COUNT FOR DISK READ/WRITE ERRORS
*
*       L I N E    P R I N T E R    E R O M    E Q U A T E S
*
LPINIT  EQU     $EBC0           INIT PRINTER PIA
LIST    EQU     $EBCC           PRINT CONTENTS OF 'A'
LDATA   EQU     $EBE4           PRINT STRING, CR/LF
LDATA1  EQU     $EBF2           PRINT STRING, NO CR/LF
*
*       E X B U G   E Q U A T E S    F O R    M D O S
*
INCHNP  EQU     $F015           INPUT CHARACTER (NO PARITY)
OUTCH   EQU     $F018           OUTPUT ONE CHARACTER
PCRLF   EQU     $F021           PRINT LF/CR
PDATA   EQU     $F024           PRINT STRING
SBIT$   EQU     $FCFD           BIT 7 INDICATES IRQ OCCURRED (IF CLEARED)
BRKPT$  EQU     $FF1F           MAID'S BREAKPOINT TABLE (8 FDB'S)
BKPIN$  EQU     $FF4F           EXBUG BREAKPOINTS IN MEMORY (FROM CONTINUE CMD)
AECHO   EQU     $FF53           INPUT CHARACTER ECHO FLAG (0=>ECHO)
IRQ$SVC EQU     $FFF8           IRQ VECTOR
SWI$VC  EQU     $FFFA           SWI VECTOR
NMI$VC  EQU     $FFFC           NMI VECTOR
XSTAK$  EQU     $FF8A           EXBUG STACK
MAID$   EQU     $F0F3           MAID ENTRY POINT
XREG$P  EQU     $FF16           MAID P-REG
XREG$X  EQU     $FF18           MAID X-REG
XREG$A  EQU     $FF1A           MAID A-REG
XREG$B  EQU     $FF1B           MAID B-REG
XREG$C  EQU     $FF1C           MAID C-REG
XREG$S  EQU     $FF1D           MAID S-REG
BRKPE$  EQU     $FF63           END OF MAID BREAKPOINT TABLE
CNACI$  EQU     $FCF4           CONSOLE ACIA
*
*       SPECIAL MACRO FOR THE CENTRONIX PRINTERS TO PRINT TITLES
*
*TITLE  MACR
*       TTL     \0
*       ENDM
        LIST    1
1
