.in 10
.sp
.un 5
CNFG:BIGCACHESWAPSECTOR
.br
This 3 byte entry contains a JMP to cache logic used by SDOS to manage a
large disk cache.  (D) points to a SECTORDB: block containing a description
(DISKINFO and LSN) of a sector which SDOS would like to retrieve; (X) points
to an RDSI: block in which to place the sector if found. The cache logic
determines if it has that sector; if not, it returns with carry set. If the
cache has that sector, and the RDSI: has DISKINFO of 0 (i.e., dummy),
then the sector contents are transferred from the cache to
RDSI:SECTORBUFFER, and the carry is returned reset. If the cache has that
sector, and the RDSI:DISKINFO<>0 (i.e., RDSI contains a valid sector), then
the cache swaps its sector information with the contents of the RDSI, and
returns carry reset. In either case, the cache need only copy the sector
contents to RDSI:SECTORBUFFER (SDOS will fill in the other fields),
and copy the RDSI:STATE flag (i.e, clean or dirty); the cache forgets it
had the desired sector.
.sp
.un 5
CNFG:BIGCACHEFINDOLDEST
.br
This 3 byte entry contains a JMP to cache logic used by SDOS to help dump
the cache efficiently. (X) points to RDSI.  Finds oldest, dirty sector in
cache; then finds lowest dirty LSN in same cylinder.  If not found (i.e., no
dirty LSNs anywhere in cache) returns carry set. If found, sector is
traded as described under CNFG:BIGCACHESWAPSECTOR.
.sp
.un 5
CNFG:BIGCACHEFINDNEXT
.br
This 3 byte entry contains a JMP to cache logic used by SDOS to help dump
the cache efficiently.  (X) points to an RDSI: block. (D) points to an RDSI:
block with RDSI:CYLINDER filled in (by DRIVER:DISKLSNTOPSN) to match
RDSI:LSN. Finds lowest LSN that is larger than RDSI:LSN specified by (D),
such that LSN is dirty and is in same cylinder.  If not found, returns carry
set.  If found, sector is traded as described under CNFG:BIGCACHESWAPSECTOR.
.sp
.un 5
CNFG:BIGCACHEFINDDISK
.br
This 3 byte entry contains a JMP to cache logic used by SDOS to help flush
sectors from a particular drive to the cache. (X) contains DISKINFO pointer.
Finds oldest, dirty sector in cache from drive with DCB matching DISKINFO;
then finds lowest dirty LSN in same cylinder for that drive. Otherwise,
results and exits are identical to CNFG:BIGCACHEFINDOLDEST.
.sp
.un 5
CNFG:BIGCACHEFLUSHDISK
.br
This 3 byte entry contains a JMP to cache logic used by SDOS to dismount
a particular drive from the cache. (X) contains a DISKINFO pointer.
Scans cache, deleting any cached sectors from drive with DCB matching
DISKINFO pointer.  This routine will not be called until SDOS has
cleared all dirty LSNs from the cache.
