ENCRYPTED OBJECT FILES

An encrypted file is one whose content is not in a directly usable
form. Under SDOS, encrypted object files contain proprietary programs
which are designed to run on only a limited number of CPUs. Some
programs are proprietary to Software Dynamics; other programs are
proprietary to other vendors. Software Dynamics provides a tool to
allow vendors to encrypt their own object programs or suite of
programs.

An encrypted program is decrypted by SDOS while loading into memory
by use of an Encryption Key which is a function of the serial numbers
of the CPUs on which the program is authorized run, and a 48 bit
"application suite" number embedded in the object file.

SDOS zeros the address space when loading an encrypted file whose
Encryption Key is different than the Encryption Key of the last file
loaded.  This prevents "Trojan Horse" software from obtaining a
snapshot of a previously-executing program.  Only programs with the
same encryption key may pass control (and non-zero data) to one
another.  This is a common requirement of an "application suite".

Encrypted object files have an un-encrypted 1st object record, followed
by the rest of the file in an encrypted format. The encrypted portion
of the file, once un-encrypted, is in standard SDOS load record format,
with the exception that no skip records are allowed (decrypting skip
records is simply a waste of time).

The first object record starts with a byte containing :05, signifying
this file is an encrypted object file. The SerialNumberCount specifies
how many serial numbers this object file is encrypted to run on.
Following the SerialNumberCount are 6 bytes of Application Suite number
(typically a random number chosen at time of encryption).  Last are a
series of 8 byte Serial Numbers on which this object file is authorized
to run. These serial numbers are in a clear text form so they can be
easily inspected by a utility program.
